VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CSubList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' ***************************************************************************************
' Declarations
' ***************************************************************************************

Implements ISubClass

Private m_ListView As ListView
Private m_CurrentItem As LVITEM
Private m_SysImgList As Long


' ***************************************************************************************
' Initialization, finalization
' ***************************************************************************************
Public Sub ConstructObject(ByVal lvw As ListView)
    Set m_ListView = lvw
    Call SubClass.Recipients.Add(Me)
    Call AssignSysImageList
End Sub
Private Sub AssignSysImageList()
    m_SysImgList = VB6Core.GFileUtil.GetSystemImageList
    If m_SysImgList <> 0 Then
        Call SendMessage(m_ListView.hWnd, LVM_SETIMAGELIST, LVSIL.Small, m_SysImgList)
    End If
End Sub


' ***************************************************************************************
' Methods
' ***************************************************************************************
Public Sub RefreshList(Optional ByVal so As ShellObject)
On Error GoTo hell
    Call m_ListView.ListItems.Clear
    If so Is Nothing Then
        Set so = New ShellObject
        so.BindToDesktop
    End If
    Dim i As Long
    so.SubMode = 0
    so.RefreshSubItems
    For i = 1 To so.SubItemCount
        Call AddItem(so.SubItems(i))
    Next i
    Exit Sub
hell:
End Sub
Private Function AddItem(ByVal so As ShellObject) As Boolean
On Error GoTo hell
    m_CurrentItem.pszText = StrPtr(String$(MAX_PATH, 0))
    Call lstrcpyA(ByVal m_CurrentItem.pszText, ByVal so.DisplayName)
    m_CurrentItem.cchTextMax = MAX_PATH
    m_CurrentItem.iImage = so.IconIndex(0, 0)
    m_CurrentItem.iItem = m_ListView.ListItems.Count
    m_CurrentItem.mask = LVIF.Text Or LVIF.Image
    Call m_ListView.ListItems.Add ' manipulate msg in the WndProc
    Exit Function
hell:
End Function


' ***************************************************************************************
' Subclassing
' ***************************************************************************************
Private Property Get ISubClass_Handle() As Long
    ISubClass_Handle = m_ListView.hWnd
End Property
Private Sub ISubClass_WndProc(ByVal message As SubClass.CMessage)
    Select Case message.wMsg
        Case LVM_SETIMAGELIST
            ' use sys il only
            If message.lParam <> m_SysImgList Then
                message.Handled = True
            End If
        Case LVM_INSERTITEM
            ' trick listview
            Call CopyMemory(ByVal message.lParam, m_CurrentItem, Len(m_CurrentItem))
    End Select
End Sub

