Attribute VB_Name = "MApiSubControls"
Option Explicit

Public Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (ByRef dest As Any, ByRef source As Any, ByVal cb As Long)
Public Declare Function lstrcpyA Lib "kernel32" (ByRef sDest As Any, ByRef sSource As Any) As Long
Public Declare Function SendMessage Lib "user32.dll" Alias "SendMessageA" _
    (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Public Const MAX_PATH = 260

Public Const LVM_FIRST = &H1000
Public Const LVM_GETIMAGELIST = LVM_FIRST + 2
Public Const LVM_SETIMAGELIST = LVM_FIRST + 3
Public Const LVM_INSERTITEM = LVM_FIRST + 7
Public Enum LVSIL
    Normal = 0
    Small = 1
    state = 2
End Enum
Public Enum LVIF
    Text = &H1
    Image = &H2
    Param = &H4
    state = &H8
End Enum
Public Type LVITEM
    mask As LVIF
    iItem As Long
    iSubItem As Long
    state As Long
    stateMask As Long
    pszText As Long
    cchTextMax As Long
    iImage As Long
    lParam As Long
    indent As Long
End Type

Public Const WM_NOTIFY = &H4E
Public Const TVM_FIRST = &H1100
Public Const TVM_GETIMAGELIST = TVM_FIRST + 8
Public Const TVM_SETIMAGELIST = TVM_FIRST + 9
Public Const TVM_INSERTITEM = TVM_FIRST + 0
Public Const TVM_EXPAND = TVM_FIRST + 2
Public Const TVM_GETITEM = TVM_FIRST + 12
Public Const TVN_FIRST = -400&    ' uns
Public Const TVN_ITEMEXPANDING = (TVN_FIRST - 5)

Public Enum TVSIL
    Normal = 0
    state = 2
End Enum
Public Enum TVIF
    Text = &H1
    Image = &H2
    Param = &H4
    state = &H8
    Handle = &H10
    SelectedImage = &H20
    Children = &H40
End Enum
Public Type TVITEM
    mask As Long
    hItem As Long
    state As Long
    stateMask As Long
    pszText As Long
    cchTextMax As Long
    iImage As Long
    iSelectedImage As Long
    cChildren As Long
    lParam As Long
End Type
Public Type TVINSERTSTRUCT
    hParent As Long
    hInsertAfter As Long
    item As TVITEM
End Type
Public Type POINTAPI
    X As Long
    y As Long
End Type
Public Type NMHDR
  hwndFrom As Long
  idFrom As Long
  code  As Long
End Type
Public Type NMTREEVIEW
    hdr As NMHDR
    action As Long
    itemOld As TVITEM
    itemNew As TVITEM
    ptDrag As POINTAPI
End Type


